import ak_ from './src/plugins/assets/ak.js'
import http_ from './src/plugins/assets/http.js'
import session_ from './src/plugins/session';
import services_ from './src/plugins/services';
import service_ from './src/plugins/service';
import base_ from './src/plugins/components/base.js'
import base2_ from './src/plugins/components/base2.js'
import platform from './src/plugins/platform';
import VueBus from 'vue-bus'
import ElementUI from 'element-ui'
import Router from 'vue-router'
import VueI18n from 'vue-i18n'
import {ua} from './src/plugins/assets/ua.js';
import config_ from './src/plugins/assets/config.js'
import route from './src/plugins/route';
import zh_CN from './src/i18n/zh-CN'
import en_US from './src/i18n/en-US'


import BSInput from './src/plugins/components/BSInput.vue'
import BSButton from "./src/plugins/components/BSButton";
import BSSelect from "./src/plugins/components/BSSelect";
import BSRadio from "./src/plugins/components/BSRadio";
import BSCheckbox from "./src/plugins/components/BSCheckbox";
import BSDatePicker from "./src/plugins/components/BSDatePicker";
import BSCascader from "./src/plugins/components/BSCascader";
import BSInputNumber from "./src/plugins/components/BSInputNumber";
import BSUpload from "./src/plugins/components/BSUpload";
import BSTable from "./src/plugins/components/BSTable";
import BSLink from "./src/plugins/components/BSLink";
import BSImage from "./src/plugins/components/BSImage";
import BSTag from "./src/plugins/components/BSTag";
import BSVerCode from "./src/plugins/components/BSVerCode";

import App_ from "./src/App"


let bstarter = {}
var App
var routes
var locales = {}


bstarter.install = function(Vue, options) {

  ak_.msg.vue = Vue
  Vue.observable(session_)
  Vue.observable(route)

  Vue.use(VueBus)
  service_.bus = Vue.prototype.$bus

  Vue.use(Router)
  Vue.use(ElementUI)
  Vue.use(VueI18n)

  Vue.prototype.$ak = ak_;
  Vue.prototype.$http = http_;
  Vue.prototype.$service = service_;
  Vue.prototype.$ua = ua;
  Vue.prototype.$route2 = route;


  if(!ua.isApp){
    Vue.prototype.$platform = platform.destop
  }

  Vue.component(BSInputNumber.name, BSInputNumber)
  Vue.component(BSDatePicker.name, BSDatePicker)
  Vue.component(BSCascader.name, BSCascader)
  Vue.component(BSCheckbox.name, BSCheckbox)
  Vue.component(BSButton.name, BSButton)
  Vue.component(BSSelect.name, BSSelect)
  Vue.component(BSRadio.name, BSRadio)
  Vue.component(BSInput.name, BSInput)
  Vue.component(BSUpload.name, BSUpload)
  Vue.component(BSTable.name, BSTable)
  Vue.component(BSLink.name, BSLink)
  Vue.component(BSImage.name, BSImage)
  Vue.component(BSTag.name, BSTag)
  Vue.component(BSVerCode.name, BSVerCode)

  const router = new Router({
    routes: routes
  })

  router.beforeEach((to, from, next) => {
    to.meta.key = (((1+Math.random())*0x10000)|0).toString(16).substring(1)
    next()
  })

  const i18n = new VueI18n({
    locale: 'zh-CN',
    messages: {
      'zh-CN': {'lang':locales['zh-CN']},
      'en-US': {'lang':locales['en-US']},
    }
  })

  App = App ? App : App_
  new Vue({
    el: '#app',
    i18n,
    router,
    components: { App },
    template: '<App/>'
  })



}

bstarter.setServices = function(srvd) {
  Object.assign(services_,srvd)
  service_.defined = services_
}

bstarter.setApp = function(app) {
  App = app
}

bstarter.setRoutes2 = function(rt,fpath) {

  let path = fpath === '/' ? rt.path : (fpath + '/' + rt.path)
  let name = rt.name
  let needLogin = ak.utils.isEmpty(rt.needLogin) ? true : rt.needLogin
  let children = rt.children
  if(children){
    for(let index2 = 0; index2 < children.length; index2++) {
      bstarter.setRoutes2(children[index2],path)
    }
  }

  route.defined[path] = {name:name,path:path,needLogin:needLogin}
}


bstarter.setRoutes = function(rt) {

  for(let index = 0; index < rt.length; index++) {

    let path = rt[index].path
    let name = rt[index].name
    let needLogin = ak.utils.isEmpty(rt[index].needLogin) ? true : rt[index].needLogin
    let children = rt[index].children
    if(children){
      for(let index2 = 0; index2 < children.length; index2++) {
        bstarter.setRoutes2(children[index2],path)
      }
    }

    route.defined[path] = {name:name,path:path,needLogin:needLogin}
  }

  routes = rt

}

bstarter.setConfig = function(cfg) {
  config_.sys = Object.assign(config_.sys,ak.utils.cloneBySerialize(cfg.sys))
  config_.http = Object.assign(config_.http,ak.utils.cloneBySerialize(cfg.http))
  config_.file = Object.assign(config_.file,ak.utils.cloneBySerialize(cfg.file))
  config_.sso = Object.assign(config_.sso,ak.utils.cloneBySerialize(cfg.sso))
  config_.auth = Object.assign(config_.auth,ak.utils.cloneBySerialize(cfg.auth))
}

bstarter.setLocale = function(local,local_obj) {
  if(local == 'zh-CN')
    locales[local] = Object.assign(zh_CN,local_obj)
  else if(local == 'en-US')
    locales[local] = Object.assign(en_US,local_obj)
}

export default bstarter;
export var base = base_
export var base2 = base2_
export var ak = ak_
export var http = http_
export var session = session_
export var config = config_
