import { ua } from './ua'


import Vue from 'vue'

export const SHELL = {
  GET_TOKEN: {
    'functionName': 'getToken',
    'dataObject': {
      'jsFunction': 'SHELL_CB.getToken',
      'isNull': 'true',
      'jsData': {}
    }
  },
  HIDE_FHONE_TITLE: {
    'functionName': 'naviInit',
    'dataObject': {
      'setVisible': { 'visibility': false }
    }
  }
}

/**
 * 外部调用API
 */

// 获取token
export function getToken(cbparam) {
  callShell(SHELL.GET_TOKEN, null, cbparam)
}

export const EBType = {}
EBType.getToken = 'getToken'

/**
 * 壳返回回调
 */
export const SHELL_CB = {

  getToken: function(data) {
    handleBackData(data, EBType.getToken, (retData) => {

      console.log('从壳中拿到的agent信息',retData)

      if(ua.isEmpty(retData.token)){

        

      }
     
    })
  }
}

// 处理调壳返回的结果
function handleBackData(src, eventType, reformateData) {

  if (src && src.nativeData) {

    const data = src.nativeData
    Vue.$log(('壳' + eventType + '类型调用成功！返回原始数据：' + JSON.stringify(data)))
    
    // alert(JSON.stringify(data))
    const ret = reformateData(data)
    
  } else {
    Vue.$log('壳' + eventType + '类型调用，返回结果异常！为空或没有nativeData节点')
  }

}

window.SHELL_CB = SHELL_CB


// 唤起壳功能
export function callShell(fnModel, param, cbparam) {
  if (fnModel) {

    const jsonObj = JSON.parse(JSON.stringify(fnModel))

    if (!ak.isEmpty(param)) 
      jsonObj.dataObject = Object.assign({}, jsonObj.dataObject, param)

    if (!ak.isEmpty(cbparam)) 
      jsonObj.dataObject.jsData = { cbparam }

    if (ak.isEmpty(jsonObj.dataObject.actions)) { 
      jsonObj.dataObject.actions = '' 
    }

    const requestJson = JSON.stringify(jsonObj)
    console.log('壳调用json：' + requestJson)

    if (ua.iPad || ua.iPhone) {
      JSonString(requestJson)
    } else {
      window.jsObj.jsCallAndroid(requestJson)
    }
  }
}

