
import { fromEvent } from 'rxjs';
import config from '../assets/config.js'
import ak from '../assets/ak.js'
import session from '../session'
import route from '../route'
import selector from "../selector";

export default {
  props: {
    value: {
      type: Object,
      default: () => {
        return {default:true}
      }
    },
    mod: {
      type: Object,
      default: () => {
        return {default:true}
      }
    },
    cname:{
      type: String
    }
  },
  data() {
    return {
      baseCtl:false,
      fullName:undefined,
      sname:undefined,
      model:{
        hiddenValidate:false,
        validateResult:{
          messages:[],
          message:'',
          isSuccess:true,
          pending:false
        }
      },
      modelData:{},
      needLoadData:false,
      needProcessEvent:false,
      isExtend:false
    }
  },
  mounted() {

    if(this.sname == 'page'){
      let self = this
      this.$service.callService('init').then(()=>{
      })
    }

    if(route.currentUrl != window.location.href){
      route.currentUrl = window.location.href
      let routeDefined = route.defined[ak.http.getRouteUrl(route.currentUrl)]
      if(routeDefined && routeDefined.needLogin){
        this.$service.callService('getToken').then((data)=>{
          if(!session.sys.isLogined){
            this.$service.callService('logout')
          }
        })
      }

    }

    this.processModel()

    this.needLoadData = Object.prototype.toString.call(this.$options.methods.loadData) == "[object Function]"

    if(this.needLoadData){
      this.$bus.on('porcessData', (data) => {

        let cb = this.$options.methods.loadData.bind(this)
        cb(data)

      })
    }

    if(this.needProcessEvent){
      this.$bus.on('processEvent', (data) => {

        let cb = this.$options.methods.processEvent.bind(this)
        cb(data)
      })
    }

  },
  methods: {
    createDefaultModel2(){

      let model2 = {
        label: '',
        tag:'',
        data: {},
        visible:true,
        readonly: false,
        disabled: false,
        required: false,
        clearable: true,
        validateType: '',
        validateGroup: '',
        validateReg: '',
        inputAlign: 'left',
        validateToken: 0,
        hiddenValidate:false,
        validateResult: {
          messages: [],
          message: '',
          isSuccess: true,
          pending: false
        }
      }

      if(this.$options.methods.createDefaultModel){
        return Object.assign(this.$options.methods.createDefaultModel(),model2)
      }else{
        return model2
      }

    },
    loadData(data){

    },
    processEvent(event){

    },
    processModel(){

      this.fullName = this.getCtlName(this)

      if(this.$props.mod.default === true){
        this.modelData = this.createDefaultModel2()
      }else{
        let defaultModel = this.createDefaultModel2()
        this.modelData = Object.assign({},defaultModel,this.$props.mod)
      }

      this.modelData = this.locale(this.modelData)
      this.model = ak.utils.cloneBySerialize(this.modelData)

      if(!this.isExtend) {
        this.$set(session.regedit, this.fullName, {model: this.model, ctl: this, name: this.fullName})
        selector.index_add(this.sname,this.fullName)
        console.log('regedit component ' + this.fullName)
      }

    },
    getCtlName(ctl){

      if(!ctl.$props)
        return ''

      let ctlName = ctl.$ak.utils.isEmpty(ctl.$props.cname) ? ctl.$data.vname : ctl.$props.cname

      if(ctl.$data.isExtend){
        return ''
      }

      if(ak.utils.isEmpty(ctlName)){
        ctlName = ak.utils.guid2()
      }
      ctlName = ctlName.replace(/RNUM/, ak.utils.guid2())

      this.sname = ctlName

      if(ak.utils.isEmpty(ctlName)){
        return ''
      }

      let parentName_s = undefined
      let parent = ctl.$parent
      while(parent){


        if(!this.$ak.utils.isEmpty(parent.$data.fullName)){
          parentName_s = parent.$data.fullName
          break
        }

        if(!(parent.$options.methods && Object.prototype.toString.call(parent.$options.methods.getCtlName) == "[object Function]")){
          parent = parent.$parent
          continue
        }else if(parent.$data.isExtend){
          parent = parent.$parent
          continue
        }else{
          break
        }

      }


      if(parent){

        let parentName = undefined
        if(parentName_s){
          parentName = parentName_s
        }else {
          parentName = parent.$options.methods.getCtlName.bind(parent)(parent)
        }


        let parent2 = ctl.$parent
        while(parent2){

          if(!this.$ak.utils.isEmpty(parent2.$data.fullName)){
            break
          }

          if(!(parent2.$options.methods && Object.prototype.toString.call(parent2.$options.methods.getCtlName) == "[object Function]")){

            parent2.$data.fullName = parentName
            parent2 = parent2.$parent
            continue
          }else if(parent2.$data.isExtend){

            parent2.$data.fullName = parentName
            parent2 = parent2.$parent
            continue
          }else{
            break
          }
        }


        if(ctl.$ak.utils.isEmpty(parentName)){
          return ctlName
        }else{
          return parentName + '.' + ctlName
        }

      }else{
        return ctlName
      }

    },
    service(serviceObj){

      let obj = serviceObj.before()

      return serviceObj.process(obj).then((res)=>{

        Promise.resolve(serviceObj.after(res))

      })

    },
    getValidateResult(onlyError,group){

      let isSuccess = true
      let messages = []

      for(var key in session.regedit){

        let ctl = session.regedit[key]

        if(!ctl.ctl.validateCtl)
          continue


        isSuccess = ctl.model.validateResult.isSuccess && isSuccess
        if(!ctl.model.validateResult.isSuccess){

          messages.push(...ctl.model.validateResult.messages)

        }

      }

      return {"isSuccess":isSuccess,"messages":messages}

    },
    validateAll(onlyError = true,group = ''){

      let isSuccess = true
      let promises = []

      for(var key in session.regedit){

        let ctl = session.regedit[key]

        if(!ctl.ctl.validateCtl)
          continue

        if(ctl.model.validateGroup != group)
          continue

        let func = ctl.ctl.$options.methods.validate.bind(ctl.ctl)

        let promiseV = func(true)
        if(promiseV){
          promises.push(promiseV)
        }

      }

      let self = this
      return Promise.all(promises)
        .then((result) => {

          let validateResult = self.getValidateResult(onlyError,group)
          return Promise.resolve(validateResult)

        })

    },
    selector(express){
      return this.$ak.utils.selector(express)
    },
    locale(obj){

      if(Object.prototype.toString.call(obj) == '[object Object]'){

        for(let key in obj){
          obj[key] = this.locale(obj[key])
        }
        return obj

      }else if(Object.prototype.toString.call(obj) == '[object Array]'){

        for(let key in obj){
          obj[key] = this.locale(obj[key])
        }
        return obj

      }else if(Object.prototype.toString.call(obj) == '[object String]'){

        if(this.$ak.utils.isEmpty(obj))
          return ''

        if(obj.startWith("lang.")){
          return this.$t(obj)
        }else{
          return obj
        }

      }else{
        return obj
      }

    },
    reset(){
      this.reset2(this.model,this.modelData)
    },
    reset2(dest,source){

      for(var p in source){

        if(Object.prototype.toString.call(source[p]) == "[object Object]"){

          if(dest.hasOwnProperty(p)){
            this.reset2(dest[p],source[p])
          }
        }else if(Object.prototype.toString.call(source[p]) == "[object Array]"){

          if(dest.hasOwnProperty(p) && String(p) !== 'items'){
            dest[p] = source[p];
          }
        }else{
          if(dest.hasOwnProperty(p)){
            if(!!source[p] && typeof source[p] === 'string' && source[p].startWith("lang.")) {
              dest[p] = this.$t(source[p])
            } else {
              dest[p] = source[p];
            }
          }
        }
      }

    },
    validate(useAll) {
      return Promise.resolve()
    }
  },
  computed: {
    config(){
      return config;
    },
    session(){
      return session;
    },
    route(){
      return route
    }
  },
  watch:{

    'session.regeditc':{
      handler(val){

        let event = JSON.parse(val)

        if(this.vname && this.vname == 'page'){
          this.$bus.$emit('processEvent',event)
        }

      }
    },
    'model.validateToken':{
      handler(val,oldval){
        if(oldval != undefined && val != 0)
        {
          this.validate()
        }
      },
      deep: false
    }

  },
  beforeRouteEnter(to, from, next) {

    console.log('beforeRouteEnter')
    next();
  },
  beforeRouteUpdate(to, from, next) {

    console.log('beforeRouteUpdate')

    next();
  },
  beforeRouteLeave(to, from, next) {

    console.log(this.route.history)
    console.log('beforeRouteLeave')
    console.log(from)
    console.log(to)

    next();
  },
  beforeDestroy() {

    if(!this.isExtend){
      this.$delete(session.regedit,this.fullName)
      selector.index_delete(this.sname,this.fullName)
    }

    if(this.needLoadData){
      this.$bus.off('porcessData')
      console.log('delete load data event' + this.fullName)
    }

    if(this.needProcessEvent){
      this.$bus.off('processEvent')
      console.log('delete regedit event ' + this.fullName)
    }

    console.log('delete regedit component ' + this.fullName)

  },
  destroyed() {


  }
}
