import Vue from 'vue';
import { fromEvent } from 'rxjs';
import {take} from 'rxjs/operators';
import ak from '../assets/ak.js'
import service from '../service';
import session from '../session'
import config from '../assets/config.js'
import selector from "../selector";

export default {
  props: {
    value: {
      type: Object,
      default: () => {
        return { default:true }
      }
    },
    mod: {
      type: Object,
      default: () => {
        return {default:true}
      }
    },
    cname:{
      type: String
    },
    cusValidate: {
      type: Function
    },
    textRender: {
      type: Function
    }
  },
  data() {
    return {
      fullName:undefined,
      sname:undefined,
      isExtend:false,
      model:{
        hiddenValidate:false,
        validateResult:{
          messages:[],
          message:'',
          isSuccess:true,
          pending:false
        }
      },
      modelData: {}
    }
  },
  mounted() {

    /*
    if(!this.$parent.$data.isExtend){
      this.processModel()
    }*/

    this.processModel()

  },
  methods: {
    createDefaultModel2(){

      let model2 = {
        label: '',
        tag:'',
        data: {},
        visible:true,
        readonly: false,
        disabled: false,
        required: false,
        clearable: true,
        validateType: '',
        validateGroup: '',
        validateReg: '',
        inputAlign: 'left',
        validateToken: 0,
        hiddenValidate:false,
        validateResult: {
          messages: [],
          message: '',
          isSuccess: true,
          pending: false
        }
      }

      if(this.$options.methods.createDefaultModel){
        return Object.assign(this.$options.methods.createDefaultModel(),model2)
      }else{
        return model2
      }

    },
    processModel(pmodel) {
      
      this.fullName = this.getCtlName(this)

      if(this.$props.mod.default === true){
        this.modelData = this.createDefaultModel2()
      } else {
        let defaultModel = this.createDefaultModel2()
        if(pmodel){
          this.modelData = Object.assign({},defaultModel,pmodel)
        }else{
          this.modelData = Object.assign({},defaultModel,this.$props.mod)
        }

      }

      this.modelData = this.locale(this.modelData)
      this.model = ak.utils.cloneBySerialize(this.modelData)

      if(!this.isExtend){
        this.$set(session.regedit,this.fullName,{model:this.model,ctl:this,name:this.fullName})
        selector.index_add(this.sname,this.fullName)
        console.log('regedit component ' + this.fullName)
      }
    },
    getCtlName(ctl) {

      if(!ctl.$props)
        return ''

      let ctlName = ctl.$ak.utils.isEmpty(ctl.$props.cname) ? ctl.$data.vname : ctl.$props.cname

      if (ctl.$data.isExtend) {
        return ''
      }

      if(ak.utils.isEmpty(ctlName)){
        ctlName = ak.utils.guid2()
      }
      ctlName = ctlName.replace(/RNUM/, ak.utils.guid2())

      this.sname = ctlName

      if(ak.utils.isEmpty(ctlName)){
        return ''
      }

      let parentName_s = undefined
      let parent = ctl.$parent
      while(parent){

//        console.log("fullname:" + parent.$options._componentTag + "----" + parent.$data.vname + "-----" + parent.$data.fullName)
        if(!this.$ak.utils.isEmpty(parent.$data.fullName)){
          parentName_s = parent.$data.fullName
          break
        }
        if(!(parent.$options.methods && Object.prototype.toString.call(parent.$options.methods.getCtlName) == "[object Function]")){
          parent = parent.$parent
          continue
        }else if(parent.$data.isExtend){
          parent = parent.$parent
          continue
        }else{
          break
        }

      }
      if(parent){
        let parentName = undefined
        if(parentName_s) {
          parentName = parentName_s
        } else {
          parentName = parent.$options.methods.getCtlName.bind(parent)(parent)
        }

        let parent2 = ctl.$parent
        while(parent2){
          if(!this.$ak.utils.isEmpty(parent2.$data.fullName)){
            break
          }
          if(!(parent2.$options.methods && Object.prototype.toString.call(parent2.$options.methods.getCtlName) == "[object Function]")){

            parent2.$data.fullName = parentName
            parent2 = parent2.$parent
            continue
          }else if(parent2.$data.isExtend){

            parent2.$data.fullName = parentName
            parent2 = parent2.$parent
            continue
          }else{
            break
          }
        }
        if(ctl.$ak.utils.isEmpty(parentName)){
          return ctlName
        }else{
          return parentName + '.' + ctlName
        }
      } else {
        return ctlName
      }
    },
    validate(useAll) {

      let firedvalidate = this.$ak.utils.isEmpty(useAll) ? false : useAll
      let promiseV

      this.model.validateResult.messages = []
      this.model.validateResult.isSuccess = false

      let value = this.model.value

      if(this.$ak.utils.isEmpty(this.model.disabled) || !this.model.disabled){

        if(this.model.required){
          if(this.$ak.utils.isEmpty(value)){

            this.model.validateResult.messages.push({'id': this.fullName ,message:this.locale(this.model.label) + '不能为空',level:8})
            this.settle(this)
            return Promise.resolve()
          }
        }

      }


      if(!this.$ak.utils.isEmpty(value)){

        if(!this.model.validateType == ''){


          if(this.model.validateType == 'EMAIL'){

            if(!this.$ak.utils.isEmail(value)){
              this.model.validateResult.messages.push({'id': this.fullName ,message:this.locale(this.model.label) + '格式不正确',level:8})
            }

            this.settle(this)

          }else if(this.model.validateType == 'MONEY'){

            if(!this.$ak.utils.isEmail(value)){

              this.model.validateResult.messages.push({'id': this.fullName ,message:this.locale(this.model.label) + '格式不正确',level:8})
            }

            this.settle(this)

          }else if(this.model.validateType == 'REG'){

            var reg = new RegExp(this.model.validateReg);
            if(!reg.test(value)){
              this.model.validateResult.messages.push({'id': this.fullName ,message:this.locale(this.model.label) + '格式不正确',level:8})

            }
            this.settle(this)

          }else if(this.model.validateType == 'CUS'){

            let validating = this.locale('lang.base.validate.validating')
            this.model.validateResult.message = validating
            this.model.validateResult.pending = true

            let vc = this.$props.cusValidate.bind(this)
            let pro = vc({value:value,fullName:this.fullName},this.model)

            let self  = this
            if(Object.prototype.toString.call(pro) == "[object Promise]"){

              promiseV = pro.then((res)=>{

                if(!self.$ak.utils.isEmpty(res)){
                  res.id = this.fullName
                  self.model.validateResult.messages.push(res)
                }


                self.model.validateResult.pending = false
                self.settle(self)

                return Promise.resolve()

              })

            }else{

              if(!self.$ak.utils.isEmpty(pro))
                self.model.validateResult.messages.push(pro)

              self.model.validateResult.pending = false
              self.settle(self)

            }

          }else{

            let validateTypeError = this.locale('lang.base.validate.validateTypeError')
            this.model.validateResult.messages.push({'id': this.fullName ,message:validateTypeError,level:8})
            this.settle(this)

          }
        }else{
          this.settle(this)
        }
      }else{

        this.model.validateResult.isSuccess = true

      }

      if(promiseV)
        return promiseV
      else
        return Promise.resolve()

    },
    settle(self){

      let isSuccess = false
      let message = ''

      if(self.model.validateResult.messages.length > 0 ){

        self.model.validateResult.messages.forEach((item, index) => {

          isSuccess = isSuccess && item.level < 5

          if(self.$ak.utils.isEmpty(message))
            message = item.message
        })

      }else{

        isSuccess = true

      }

      self.model.validateResult.isSuccess = isSuccess
      self.model.validateResult.message = message


    },
    setEventString(id,name,attr,val,oldVal){

      let event = {
        'id':id,
        'name':name,
        'attr':attr,
        'val':val,
        'oldVal':oldVal
      }

      session.regeditc = JSON.stringify(event)
    },
    locale(obj){

      if(Object.prototype.toString.call(obj) == '[object Object]'){

        for(let key in obj){
          obj[key] = this.locale(obj[key])
        }
        return obj

      }else if(Object.prototype.toString.call(obj) == '[object Array]'){

        for(let key in obj){
          obj[key] = this.locale(obj[key])
        }
        return obj

      }else if(Object.prototype.toString.call(obj) == '[object String]'){

        if(this.$ak.utils.isEmpty(obj))
          return ''

        if(obj.startWith("lang.")){
          return this.$t(obj)
        }else{
          return obj
        }

      }else{
        return obj
      }

    },
    reset(){

      this.reset2(this.model,this.modelData)
    },
    reset2(dest,source){

      for(var p in source){

        if(Object.prototype.toString.call(source[p]) == "[object Object]"){

          if(dest.hasOwnProperty(p)){
            this.reset2(dest[p],source[p])
          }
        }else if(Object.prototype.toString.call(source[p]) == "[object Array]"){

          if(dest.hasOwnProperty(p) && String(p) !== 'items'){
            dest[p] = source[p];
          }
        }else{
          if(dest.hasOwnProperty(p)){
            if(!!source[p] && typeof source[p] === 'string' && source[p].startWith("lang.")) {
              dest[p] = this.$t(source[p])
            } else {
              dest[p] = source[p];
            }
          }
        }
      }

    }

  },
  watch:{

    'model.validateToken':{
      handler(val,oldval){
        if(oldval != undefined && val != 0)
        {
          this.validate()
        }
      },
      deep: false
    }

  },
  computed: {
    config(){
      return config;
    },
    session(){
      return session;
    },
    ctlClass() {

      let ctlTag = this.$options._componentTag
      if (this.model.readonly) {
        return ctlTag + '_readonly'
      }else if (this.model.disabled) {
        return ctlTag + '_disabled'
      }else {
        return ctlTag + '_normal'
      }

    }

  },
  beforeDestroy() {

    this.$delete(session.regedit,this.fullName)
    selector.index_delete(this.sname,this.fullName)
    console.log('delete regedit component ' + this.fullName)
  },
  destroyed() {


  }
}
