import ak from "../assets/ak";
import session from "../session";
import route from "../components/base";
import config from "../assets/config";


var router = router || {};
history.pushState(null, null, document.URL);
window.addEventListener('popstate', function(evt){
  history.pushState(null, null, document.URL);
}, false);


router = {
  defined:{},
  history:[],
  currentUrl:'',
  addHistory(url){

    let rootPath = ak.http.getRootPath(url)
    let routeUrl = ak.http.getRouteUrl(url)
    let url2 = rootPath + '#' + routeUrl

    if(this.history[this.history.length - 1] != url2){
      this.history.push(url2)
    }

  },
  replace(url){
    this.goBack(url)
  },
  reload(){
    location.reload()
  },
  goBack(url){

    if(ak.utils.isEmpty(url)){

      if(config.sys.routeType == 'browser'){
        history.back()
      }else{

        let last = this.history.pop()
        while(last){
          if(last == window.location.href){
            last = this.history.pop()
          }else{
            break;
          }
        }

        if(last)
          this.redirectUrl(last)
      }

    }else{

      if(config.sys.routeType == 'browser'){

        let fullUrl = url
        if(!url.startWith('http'))
          fullUrl = config.http.baseURL + '/#/' + url

        let rootPath = ak.http.getRootPath(fullUrl)
        let routeUrl = ak.http.getRouteUrl(fullUrl)
        let url2 = rootPath + '#' + routeUrl

        location.replace(url2)
      }else{

        let fullUrl = url
        if(!url.startWith('http'))
          fullUrl = config.http.baseURL + '/#/' + url

        let rootPath = ak.http.getRootPath(fullUrl)
        let routeUrl = ak.http.getRouteUrl(fullUrl)
        let url2 = rootPath + '#' + routeUrl

        let index2 = -1
        this.history.forEach(function (element, index, array) {
          if(element == url2 && index2 < index)
            index2 = index
        })

        if(index2 >= 0){
          this.history.splice(index2,this.history.length - index2)
          this.redirectUrl(url2)
        }else{
          this.redirectUrl(url2)
        }

      }
    }

  },
  push(url){

    let fullUrl = url
    if(!url.startWith('http')){
      if(url.startWith('?')){
        fullUrl = config.http.baseURL + url
      }else if(url.startWith('/')){
        fullUrl = config.http.baseURL + '/#' + url
      }else{
        fullUrl = config.http.baseURL + '/#/' + url
      }
    }

    let rootPath = ak.http.getRootPath(fullUrl)
    let routeUrl = ak.http.getRouteUrl(fullUrl)
    let url2 = rootPath + '#' + routeUrl

    let rootPath_c = ak.http.getRootPath()
    let routeUrl_c = ak.http.getRouteUrl()
    let url3 = rootPath_c + '#' + routeUrl_c

    if(config.sys.routeType == 'browser'){
      this.hrefUrl(url2)
    }else{
      this.addHistory(url3)
      this.redirectUrl(url2)
    }
  },
  redirectUrl(fullUrl){

    let rootPath_c = ak.http.getRootPath()
    let index = fullUrl.indexOf(rootPath_c)
    if(index >= 0){
      let thisUrl = fullUrl.substr(rootPath_c.length)
//      window.location.hash = thisUrl
      location.replace(thisUrl)
    }else{
//      window.location.href = fullUrl
      location.replace(fullUrl)
    }
  },
  hrefUrl(fullUrl){

    let rootPath_c = ak.http.getRootPath()
    let index = fullUrl.indexOf(rootPath_c)
    if(index >= 0){
      let thisUrl = fullUrl.substr(rootPath_c.length)
      window.location.hash = thisUrl
    }else{
      window.location.href = fullUrl
    }
  }

}

export default router;
