import ak from "../assets/ak";
import session from "../session";

var selector = selector || {};

selector = {

  index0:{},
  index1:{},
  index_add(sname,fullName){

    this.index_add0(sname,fullName)
    this.index_add1(sname,fullName)
  },
  index_delete(sname,fullName){

    this.index_delete0(sname,fullName)
    this.index_delete1(sname,fullName)
  },
  index_add0(sname,fullName){

    if(!this.index0[sname])
      this.index0[sname] = {}

    this.index0[sname][fullName] = true

  },
  index_delete0(sname,fullName){

    delete this.index0[sname][fullName]

  },
  index_add1(sname,fullName){

    let index = fullName.lastIndexOf('.')
    if(index > 0) {

      let parent = fullName.substr(0, index)

      if (!this.index1[parent]) {
        this.index1[parent] = {}
      }

      this.index1[parent][fullName] = true
    }

  },
  index_delete1(sname,fullName){

    let index = fullName.lastIndexOf('.')
    if(index > 0){

      let parent = fullName.substr(0,index)
      delete this.index1[parent][fullName]
    }
  },
  select(node,express){

    let store = session.regedit
    let action = ''
    let exp = ''

    if(express.startWith('##')){
      action = '##'
      exp = express.substring(2)
    }else if(express.startWith('#')){
      action = '#'
      exp = express.substring(1)
    }else if(express.startWith('>>')){
      action = '>>'
      exp = express.substring(2)
    }else if(express.startWith('>')){
      action = '>'
      exp = express.substring(1)
    }else if(express.startWith('<')){
      action = '<'
      exp = express.substring(1)
    }else if(express.startWith('=')){
      action = '='
      exp = express.substring(1)
    }


    let ctls = {}


    if(action == '#'){

      let ctls_t = {}
      if(this.index0[exp])
        ctls_t = this.index0[exp]

      for(let key in ctls_t) {

        if(node != null && !key.startWith(node)){
          continue
        }

        ctls[key] = store[key]
      }

    }else if(action == '='){

      if(node != null && !exp.startWith(node)){

      }else{
        ctls[exp] = store[exp]
      }

    }else if(action == '##'){

      let ctls_t = {}
      if(this.index0[exp])
        ctls_t = this.index0[exp]

      for(let key in ctls_t) {

        if(node != null && !key.startWith(node)){
          continue
        }

        ctls[key] = store[key]
        break
      }

    }else if(action == '>'){

      let ctls_t = {}
      if(this.index0[exp])
        ctls_t = this.index0[exp]

      let curId
      for(let key in ctls_t) {

        if(node != null && !key.startWith(node)){
          continue
        }

        curId = key
        break
      }

      if(curId){

        let children = this.index1[curId]

        for(let key in children){
          ctls[key] = store[key]
        }
      }

    }else if(action == '>>'){

      for(let key in store) {

        let ctl = store[key]
        let name = ctl.name

        if(node != null && !name.startWith(node)){
          continue
        }

        if(name.indexOf(exp + '.') >= 0){
          ctls[name] = (ctl)
        }

      }

    }else if(action == '<'){

      let ctls_t = {}
      if(this.index0[exp])
        ctls_t = this.index0[exp]

      let curId
      for(let key in ctls_t) {

        if(node != null && !key.startWith(node)){
          continue
        }

        curId = key
        break
      }

      if(curId){

        let index = curId.lastIndexOf('.')
        if(index > 0){

          let parentId = curId.substr(0,index)
          ctls[parentId] = store[parentId]
        }
      }

    }

    return this.createResultObj(ctls)

  },
  createResultObj(ctls){

    var obj = new Object;
    obj.ctls = ctls

    obj.getRef = function() {

      let val
      for(var key in this.ctls){
        let ctl = this.ctls[key]
        return ctl.ctl
      }

      return val
    };

    obj.disable = function() {

      for(var key in this.ctls){
        let ctl = this.ctls[key]
        ctl.model.disabled = true
      }

      return this
    };

    obj.enable = function() {

      for(var key in this.ctls){
        let ctl = this.ctls[key]
        ctl.model.disabled = false
      }

      return this
    };

    obj.readonly = function() {

      for(var key in this.ctls){
        let ctl = this.ctls[key]
        ctl.model.readonly = true
      }

      return this
    };

    obj.validate = function() {

      for(var key in this.ctls){
        let ctl = this.ctls[key]
        ctl.model.validateToken++
      }

      return this
    };

    obj.set = function(column,val) {

      for(var key in this.ctls){
        let ctl = this.ctls[key]
        ctl.model[column] = val
      }

      return this
    };

    obj.get = function(column) {

      let val
      for(var key in this.ctls){
        let ctl = this.ctls[key]
        return ctl.model[column]
      }

      return val
    };

    obj.setValue = function(val) {

      for(var key in this.ctls){
        let ctl = this.ctls[key]
        ctl.model.value = val
        ctl.model.validateToken++
      }

      return this
    };

    obj.getValue = function() {

      let val
      for(var key in this.ctls){
        let ctl = this.ctls[key]
        return ctl.model.value
      }

      return val
    };

    obj.getValue2 = function() {

      let val
      for(var key in this.ctls){
        let ctl = this.ctls[key]
        return ctl.model.value ? ctl.model.value : ''

      }

      return val ? val : ''
    };

    obj.reset = function(val) {

      for(var key in this.ctls){
        let ctl = this.ctls[key]
        ctl.ctl.reset()
      }

      return this
    };

    obj.getName = function() {

      let val
      for(var key in this.ctls){
        let ctl = this.ctls[key]
        return ctl.ctl.sname
      }

      return val
    };

    obj.getFullName = function() {

      let val
      for(var key in this.ctls){
        let ctl = this.ctls[key]
        return ctl.ctl.fullName
      }

      return val
    };

    obj.selector = function(express){

      let ctls = {}

      for(var key in this.ctls){

        let result = selector.select(key,express)
        Object.assign(ctls,result.ctls)
      }

      return selector.createResultObj(ctls)

    }

    return obj

  }

}

export default selector;
